
#ifndef SYSTEM_GLOBALS_H
#define SYSTEM_GLOBALS_H

/******************************************************************************/
/* System Level #include's                                                    */
/******************************************************************************/
#include "user.h"
#include "npnz16b.h"
#include "v_loop.h"
#include "i_loop.h"
#include "i_loop_b.h"

/******************************************************************************/
/* System Level #define Macros                                                */
/******************************************************************************/


/******************************************************************************/
/* Global Variable Declaration                                                */
/******************************************************************************/

extern volatile uint16_t vin_adc, vout_adc, iout_adc, iout_adc_b, v_ref, i_ref, duty_out, duty_out_b, v_cfly, v_cfly_ref, deltaD_offset, cloop_out, core_temp;
extern volatile uint16_t i_trigger, i_trigger_b;
extern volatile int16_t temperature_adc;
extern volatile int16_t isen[2];
extern volatile int16_t deltaDQ2;
//volatile int16_t maxdeltaDpos, maxdeltaDneg;
extern volatile int16_t systemstate, systemstateprevious, controlstate;
extern volatile int16_t statechanged;
extern volatile int16_t newadcavailable;
extern volatile int16_t numberofphases;
extern volatile int16_t mscounter;
extern volatile int16_t deltaD;
extern volatile int16_t rx_count;
extern volatile int16_t tx_count, low_iout_count;
extern volatile int16_t pwm2_count;
extern volatile uint8_t command_int8;
extern volatile int16_t deltaDmax;
extern volatile cNPNZ16b_t v_loop, i_loop, i_loop_b;



/******************************************************************************/
/* System Function Prototypes                                                 */
/******************************************************************************/




#endif // end of SYSTEM_GLOBALS_H
