#include <xc.h>
#include <stdint.h>
#include <stdbool.h>

#include "globals.h"

volatile uint16_t ConfigureFaultHandlers(void) {
       
    
    fault_ovp.source_obj = &vin_adc;   // Set pointer to variable to monitor
    fault_ovp.ref_obj = NULL;      // Clear pointer to "compare against" variable 
    fault_ovp.bit_mask = 0xFFFF;  // Compare all bits of SOURCE (no bit filter)
    
    fault_ovp.status.bits.type = FLTCMP_GREATER_THAN; // Select Compare-Type
    fault_ovp.counter = 0;        // Clear fault event counter
    fault_ovp.trip_level = VINADC(OVLO_IN);   // Set fault trip level
    fault_ovp.tripcnt_max = 1;    // Set counter level at which a FAULT condition will be tripped
    fault_ovp.reset_level = VINADC(OVLO_IN_RESET);   // Set fault reset level
    fault_ovp.rstcnt_max = 1000;     // Set counter level at which a FAULT condition will be cleared
    
    // User-function declarations
    fault_ovp.trip_response = &PowerSupply_Suspend; // Set pointer to user-function which should be called when a FAULT is tripped
    fault_ovp.reset_response = &ocp_reset_response; // Set pointer to user-function which should be called when a FAULT is cleared
    
    fault_ovp.status.bits.enabled = true; // Enable fault checks
    
    return (1);
}


