/*
 * File:   power_control.c
 * Author: M91406.LA
 *
 * Created on November 2, 2019, 3:52 PM
 */


#include <xc.h>
#include <stdint.h>
#include <stdbool.h>

#include "globals.h"


volatile uint16_t PowerControlStateMachine(void) {
    
    static uint16_t delay=0;
//    static uint16_t delayTest;
    
    if (systemstate != systemstateprevious) {
        statechanged = 1;
        systemstateprevious = systemstate;
    }
    
    
    switch (systemstate) {
        case off:
            if (statechanged == 1) {
                statechanged = 0; //allow for delay for on/off events
                mscounter = 0;
            }
            
            PWMDISABLED;
            PWMHOLD;

            v_ref = 0;
            i_ref = 0;//128;
//            i_ref = IOUTADC(2.8);


            if ((mscounter > 100)) //&& 
                 //   (vin_adc > VINADC(UVLO_ON)) && 
                //    (vin_adc < VINADC(OVLO_ON))  &&
                  //  (temperature_adc < TEMPERATUREON) 
            {
                systemstate = outputdischarged;
                
            }
            break;

        case outputdischarged:
            statechanged = 0;
            if (vout_adc < VOUTADC(VOUTKEEPOFFATSTARTUP)) {
                systemstate = softstart;
                PWMENABLE;
                PWMRELEASE;
//                PG4IOCONL &= 0xCFFF;
                // enable controller
                v_loop.status.bits.enable = 1;
                i_loop.status.bits.enable = 1;   
                i_loop.status.bits.invert_input = 1;   
//                i_loop_b.status.bits.enable = 1;                
            }
//                if (ENABLEINPUT == 0) {
//                    systemstate = off;
//                }
            break;
            


        case softstart:

            if (statechanged == 1) {
                statechanged = 0;
//                    Iout_PID.controlReference = IOUTADC(ILIMITACTUALAMPS);
            }
            if (newadcavailable == 1) {
                newadcavailable = 0;
                newadcavailable = 0;
                v_ref += RAMPRATE;
            }

            if (v_ref >= VINADC(VINACTUALVOLTS)) {
                v_ref = VINADC(VINACTUALVOLTS);
                systemstate = running;

                delay = 0;
            }
//                if (ENABLEINPUT == 0)//|| (vin_adc < VINADC(UVLO_OFF))
//                       // || (vin_adc > VINADC(OVLO_OFF))) 
//                {
//                    systemstate = off;
//                }
            break;

        case running:

            statechanged = 0;
//                if (ENABLEINPUT == 0)//|| (vin_adc < VINADC(UVLO_OFF)) 
//                      //  || (vin_adc > VINADC(OVLO_OFF))) 
//                {
//                    systemstate = off;
//                }
            if (newadcavailable == 1) {

                newadcavailable = 0;
                newadcavailable = 0;

            }
            break;

        case error:
            break;
    }
    
    
    return (1);
}
